unit NagyitasU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, Menus, ComCtrls, Dialogs,
  SegedU, SetU, SettingU, MeretU;

const
  {A fjlok ltezk s helyesek}
  PontFajl = 'pontok.txt';   {pontazonost szerint rendezett}
  ElFajl   = 'elek.txt';     {kezdpont-vgpont szerint rendezett}

const
  {Ennyi nagyitson lpkedhetnk vissza}
  maxnagy=5;
type
  nagy_ind=1..maxnagy;

{Hlzati adat deklarcik}
const
  maxpontdb   = 10000;
  maxszakdb   = 3*maxpontdb;
  maxeldb     = 2*maxszakdb;
  maxelp      = 6;
  maxkord     = 999999999;
  minkord     =-999999999;
  {adatszlessgek}
  maxpontq    = 6;
  maxkordq    = 10;
  maxutq      = 13;

type
  pontind   = 1..maxpontdb;   pontin0   = 0..maxpontdb;
  elind     = 1..maxeldb;     elin0     = 0..maxeldb;
  kord      = minkord..maxkord;
  pont      = string[maxpontq];
  ut        = string[maxutq];

type
  vpvgr       = array[elind] of pontind;
  kpmutvgr    = array[1..maxpontdb+1] of elind;
  kordv       = array[pontind] of kord;
  pontazv     = array[pontind] of pont;
  utv         = array[elind] of ut;

type
  haltabgraftip    = record
   pontdb:pontin0; pontaz:pontazv; xkord,ykord:kordv;
   mut:kpmutvgr; eldb:elin0; elvp:vpvgr; elut:utv;
  end;

{A rajzolshoz szksges deklarcik}
const
  ablakszin = clBlack;    {a nagytkerethez}
  hatterszin = clWhite;
  kepszele = 5;           {a kp szln lv res hely}

{A szveg igaztshoz az OutTextXY-ban}
type
  Direction=(LefTtext,RightText,TopText,BottomText,CenterText);

{A Form deklarcija}
type
  TRajzForm = class(TForm)
    MainMenu1: TMainMenu;
     mp1: TMenuItem;
      mp1_1: TMenuItem;
      mp1_2: TMenuItem;
      mp1_3: TMenuItem;
     mp4: TMenuItem;
      mp4_1: TMenuItem;
      mp4_2: TMenuItem;
      mp4_3: TMenuItem;
      mp4_4: TMenuItem;
      mp4_5: TMenuItem;
     N1: TMenuItem;
     N2: TMenuItem;
    PopupMenu1: TPopupMenu;
     pm4_1: TMenuItem;
     pm4_5: TMenuItem;
    Kep: TImage;
    StatusBar1: TStatusBar;
    procedure KepMouseDown(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure KepMouseMove(Sender: TObject; Shift: TShiftState;
                           X, Y: Integer);
    procedure KepMouseUp(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
    procedure mpAltClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    {A hlzat adatai}
    haltabgraf:haltabgraftip;
    {Koordinta minimumok, maximumok}
    xmin,xmax,ymin,ymax:real;
    {Segdvltozk, a kperny koordintkhoz}
    kpxe,kpye,vpxe,vpye:integer;
    {A rajz (Kep, Kep.Picture.Graphic) mrete (a Create definilja)}
    maxx,maxy:integer;
    {A rajzablak maximalizlt mrete a mretezshez (a Create definilja)}
    Tmaxx,Tmaxy:integer;

    {Az ablak aktulis llapota (lsd:Resize)}
    Allapot:TWindowState;
    {Az aktulis funkci kdja (pl:1_2)}
    AktFunkc:string;
    {Az aktulisan kivlasztott pont, ill. szakasz pontindexe}
    PInd,KpInd,VpInd:Pontin0;

    {A nagytshoz szksges deklarcik}
    {A tmbk els elemei a kezdkphez tartoznak}
    KEPSZORZOt:array[nagy_ind] of REAL;               {A NAGYITS MRTKE}
    KEPXMINt,KEPYMINt,                            {AKTULIS KP MIN.,MAX.}
    KEPXMAXt,KEPYMAXt:array[nagy_ind] of INTEGER;

    aktnagy:0..maxnagy;                      {hnyadik nagytsnl jrunk}
    aktnagymax:nagy_ind;                              {ennyi nagyts van}

    XSZOR,YSZOR,KEPSZORZO:REAL;       {a kezdkpre val transzfomlshoz}
    KEPXMIN,KEPYMIN,                    {az aktulis nagyts paramterei}
    KEPXMAX,KEPYMAX:INTEGER;

    VanNagyitoKeret:boolean;                          {a nagyt kerethez}
    KezdoP, MozgoP : TPoint;
    NagyitoKeret:record
     Balx,Jobbx,Felsoy,Alsoy:integer;
    end;

    {A szveg igaztsa az OutTextXY-hoz}
    AktHoriDir:Direction;
    AktVertDir:Direction;

    {A kpernyre/kpernyrl val transzformlshoz}
    FUNCTION KEPREX(MIT:REAL):INTEGER;
    FUNCTION KEPREY(MIT:REAL):INTEGER;
    procedure keprepont(i:pontind; var xe,ye:integer);
    FUNCTION KEPROLX(MIT:INTEGER):INTEGER;
    FUNCTION KEPROLY(MIT:INTEGER):INTEGER;
    procedure keprolpont(xe,ye:integer; var x,y:kord);

    {A nagytshoz, rajzolshoz}
    procedure RajzTorles;
    PROCEDURE NAGYITAS(cim:string);
    procedure KezdoKep;
    procedure NagyLep(elore:boolean);
    procedure NagyitoKeretRajz(BFP,JAP:TPoint; AktTollMod:TPenMode);

    {Rgi grafikus szubrutinok Delphi-s megvalstsai}
    procedure Line(x1,y1,x2,y2:integer);
    procedure SetColor(Szin:integer);
    procedure SetLineStyle(Style:TPenStyle; Width:byte);
    procedure OutTextXY(x,y:integer; st:string);
    procedure SetTextJustify(hori,vert:direction);
    procedure SetFillStyle(Kep:TImage; Minta,Szin:integer);

    {Egyb eljrsok}
    procedure AktFunkcSet(Funkcio,Felirat:string);
    function PontKeres(const pontaz:pontazv; db:pontin0; p:pont{mit};
      var hol:pontind):boolean;
    procedure haltabepit;
    procedure MenuBeallit;

    {A kiemelsekhez}
    procedure Bumzli(x,y,szin,szelesseg:integer);
    procedure TelepKiem(i:pontind; szin,szelesseg:integer);
    procedure SzakaszKiem(i,j:pontind; szin,szelesseg:integer);
    procedure TelepKiem1(Kiem:boolean);
    procedure SzakaszKiem1(Kiem:boolean);
    procedure KiemLevesz;
    procedure ElKereses(x0,y0:integer; var kpi,vpi:pontin0);
    procedure PontKereses(x0,y0:integer; var pi:pontin0);
    function elsorsz(kpont,vpont:pontind):elin0;

    {A lekrdezsekhez}
    procedure PontInf;
    procedure SzakInf;

  public
    {Az aktulis belltsfjl. Ha nincs CfgDefault, akkor a programbeli}
    {alaprtelmezssel ltrehozzuk (lsd:Create, ill. SetU.AlapSettings)}
    SettingNev:string;
    procedure KepRajzol;
  end;

var
  RajzForm: TRajzForm;

implementation

{$R *.DFM}

procedure TRajzForm.Line(x1,y1,x2,y2:integer);
begin
 with Kep.Canvas do begin
  MoveTo(x1,y1);
  LineTo(x2,y2);
 end;
end;

procedure TRajzForm.SetColor(Szin:integer);
begin
 Kep.Canvas.Pen.Color:=Szin;
end;

procedure TRajzForm.SetLineStyle(Style:TPenStyle; Width:byte);
begin
 with Kep.Canvas do begin
  Pen.Style:=Style;
  Pen.Width:=Width;
 end;
end;

{Ezt trlsre hasznlom (Minta:1, Szin:HatterSzin)}
procedure TRajzForm.SetFillStyle(Kep:TImage; Minta,Szin:integer);
const t:array[1..8] of TBrushStyle=
      (bsSolid, bsClear, bsHorizontal, bsVertical, bsFDiagonal,
       bsBDiagonal, bsCross, bsDiagCross); {8 fle minta van}
begin
 with Kep.Canvas do begin
  Brush.Style:=t[(Minta-1) mod 8+1];
  Brush.Color:=Szin;
 end;
end;

procedure TRajzForm.SetTextJustify(hori,vert:direction);
begin
 AktHoriDir:=hori;
 AktVertDir:=vert;
end;

{Az aktulis igaztsokkal (AktHoriDir, AktVertDir) elvgzett TextOut}
procedure TRajzForm.OutTextXY(x,y:integer; st:string);
begin
 {Mivel a TextOut-nl a szveg bal fels sarkt kell megadni,}
 {ezrt az igaztstl fggen 'odatoljuk' a koordintkat}
 with Kep.Canvas do begin
  case akthoridir of
   centertext:x:=x-TextWidth(st) div 2;
   righttext:x:=x-TextWidth(st);
  end;
  case aktvertdir of
   centertext:y:=y-TextHeight(st) div 2;
   bottomtext:y:=y-TextHeight(st);
  end;
  TextOut(x,y,st);
 end;
end;

function TRajzForm.PontKeres(const pontaz:pontazv; db:pontin0; p:pont{mit};
  var hol:pontind):boolean;
var kezd,veg:integer; pi:pontind; van:boolean;
begin
 kezd:=1; veg:=db; van:=false;
 while (kezd<=veg) and not van do begin
  pi:=(kezd+veg) div 2;
  if p=pontaz[pi] then van:=true
  else if p<pontaz[pi] then veg:=pi-1 else kezd:=pi+1;
 end;
 if not van then pi:=kezd; {hol lenne a helye}
 hol:=pi;
 PontKeres:=van;
end;

procedure TRajzForm.haltabepit;
 var i,j,k:integer;
     f:textfile; st:string; kp,vp:pont; kpi,vpi:pontind;
     van1,van2:boolean; epi:pontin0; u:ut;
 begin
    {adat minimum,maximum}
    xmin:=maxlongint;
    xmax:=-maxlongint;
    ymin:=maxlongint;
    ymax:=-maxlongint;
    {Pontok beolvassa}
    i:=0; {pontindex}
    AssignFile(f,PontFajl);
    Reset(f);
    while not eof(f) do
     with haltabgraf do begin
       inc(i);
       {a fjl pontaz- sz. rendezett}
       readln(f,st);
       pontaz[i]:=copy(st,1,maxpontq);
       xkord[i]:=StrToInt(copy(st,maxpontq+1,maxkordq));
       if xkord[i]<xmin then xmin:=xkord[i];
       if xkord[i]>xmax then xmax:=xkord[i];
       ykord[i]:=StrToInt(copy(st,maxpontq+maxkordq+1,maxkordq));
       if ykord[i]<ymin then ymin:=ykord[i];
       if ykord[i]>ymax then ymax:=ykord[i];
     end;
    CloseFile(f);
    haltabgraf.PontDb:=i;
    {lek beolvassa}
    epi:=0; {az elz pont indexe}
    j:=0; {elindex}
    AssignFile(f,ElFajl);
    Reset(f);
    while not eof(f) do
     with haltabgraf do begin
       readln(f,st);
       kp:=copy(st,1,maxpontq);
       vp:=copy(st,maxpontq+1,maxpontq);
       u:=copy(st,2*maxpontq+1,maxutq);
       van1:=PontKeres(pontaz,pontdb,kp,kpi);
       van2:=PontKeres(pontaz,pontdb,vp,vpi);
       if van1 and van2 then begin
        inc(j);
        if kpi<>epi then begin
         {j kezdpont jtt}
         for k:=epi+1 to kpi do
          mut[k]:=j;
        end;
        elvp[j]:=vpi;
        elut[j]:=u;
        epi:=kpi;
       end;
     end;
    CloseFile(f);
    {Az utols pont(ok) utni lmutat(k)}
    with haltabgraf do begin
     for k:=epi+1 to pontdb+1 do
      mut[k]:=j+1;
     eldb:=j;
    end;
    {nehogy nullval osszunk}
    if xmax=xmin then xmax:=xmax+2;
    if ymax=ymin then ymax:=ymax+2;
    {a megfelel nagytsi szorzk}
    xszor:=(maxx-2*kepszele)/(xmax-xmin);
    yszor:=(maxy-2*kepszele)/(ymax-ymin);
    {mindkt irnyban ugyanakkorval szorzunk, hogy lptkhelyes maradjon}
    if xszor<yszor then yszor:=xszor
                   else xszor:=yszor;
 end;

procedure TRajzForm.RajzTorles;                         {A rajz letrlse}
begin
 with Kep.Canvas do begin
  Brush.Style:=bsSolid;
  Brush.Color:=HatterSzin;
  {A TCanvas-nak nincs Width, Height tulajdonsga, csak a TImage-nek}
  FillRect(Rect(0,0,Kep.Width,Kep.Height));
 end;
end;

{Az aktulis kp kirajzolsa a kpernyre a mp3_2.Checked-tl fggen}
{vagy simn, vagy terhelssel a szakaszokat}
procedure TRajzForm.KepRajzol;
var i,j,x1,y1:integer; st:string; f:TFont;
begin
 KiemLevesz; RajzTorles;
 {Pontazonost}
 with settings[1] do
  if Szoveg.Kelle then begin
   SetTextJustify(CenterText,CenterText);
   f:=Kep.Canvas.Font;
   Fontba(f,Szoveg.FontRec);
   with haltabgraf do
    for i:=1 to pontdb do
     begin
      keprepont(i,kpxe,kpye);
      Pozicio(kpxe,kpye,x1,y1,szoveg);
      outtextxy(x1,y1,trim(pontaz[i]));
     end;
  end;
 {Szakaszadat}
 with settings[2] do
  if Szoveg.Kelle then begin
   SetTextJustify(CenterText,CenterText);
   f:=Kep.Canvas.Font;
   Fontba(f,Szoveg.FontRec);
   with haltabgraf do
    for i:=1 to pontdb do begin
     keprepont(i,kpxe,kpye);
     for j:=mut[i] to mut[i+1]-1 do begin
      keprepont(elvp[j],vpxe,vpye);
      Pozicio((kpxe+vpxe) div 2,(kpye+vpye) div 2,x1,y1,szoveg);
      st:=trim(elut[j]);
      outtextxy(x1,y1,st);
     end;
    end;
  end;
 {Pontok}
 with settings[1].telep[0] do
  with haltabgraf do
   for i:=1 to pontdb do
    TelepKiem(i,Szin,Szel);
 {Szakaszok}
 with settings[2].vonal[0] do begin
  setcolor(Szin);
  setlinestyle(psSolid,Vast);
 end;
 with haltabgraf do
  for i:=1 to pontdb do begin
   keprepont(i,kpxe,kpye);
   if mut[i]<=mut[i+1]-1 then
    for j:=mut[i] to mut[i+1]-1 do begin
     keprepont(elvp[j],vpxe,vpye);
     line(kpxe,kpye,vpxe,vpye);
    end;
  end;
end;

PROCEDURE TRajzForm.KezdoKep;      {kezdkp a kpernyre}
BEGIN
 KEPXMAX:=maxx;   KEPXMIN:=0;
 KEPYMAX:=maxy;   KEPYMIN:=0;
 KEPSZORZO:=1;
 {'vermels'}
 aktnagy:=1; aktnagymax:=1;
 kepxmaxt[aktnagy]:=kepxmax;
 kepxmint[aktnagy]:=kepxmin;
 kepymaxt[aktnagy]:=kepymax;
 kepymint[aktnagy]:=kepymin;
 kepszorzot[aktnagy]:=kepszorzo;
 KEPRAJZOL;
 MenuBeallit;
END;

procedure TRajzForm.NagyLep(elore:boolean);      {'megtett' nagytsokon val lpdels}
begin
 if elore then begin
  if aktnagy<aktnagymax then begin
   inc(aktnagy);
   kepxmax:=kepxmaxt[aktnagy];
   kepxmin:=kepxmint[aktnagy];
   kepymax:=kepymaxt[aktnagy];
   kepymin:=kepymint[aktnagy];
   kepszorzo:=kepszorzot[aktnagy];
   keprajzol;
   MenuBeallit;
  end
 end else
  if aktnagy>1 then begin
   dec(aktnagy);
   kepxmax:=kepxmaxt[aktnagy];
   kepxmin:=kepxmint[aktnagy];
   kepymax:=kepymaxt[aktnagy];
   kepymin:=kepymint[aktnagy];
   kepszorzo:=kepszorzot[aktnagy];
   keprajzol;
   MenuBeallit;
  end;
end;

FUNCTION TRajzForm.KEPREX(MIT:REAL):INTEGER;     {felnagyitja az x kord-t}
var s : real;
BEGIN
 S:=(MIT-KEPXMIN)*KEPSZORZO;
 IF S<-32000 THEN S:=-32000;
 IF S>32000 THEN S:=32000;
 KEPREX:=ROUND(S)+kepszele;   {a szle is rajta legyen}
END;

FUNCTION TRajzForm.KEPREY(MIT:REAL):INTEGER;     {felnagyitja az y kord-t}
var s : real;
BEGIN
 S:=(MIT-KEPYMIN)*KEPSZORZO;
 IF S<-32000 THEN S:=-32000;
 IF S>32000 THEN S:=32000;
 KEPREY:=maxy-ROUND(S)-kepszele;
END;

procedure TRajzForm.keprepont(i:pontind;      {az i. pont kpre transzf-a}
                    var xe,ye:integer);
begin
 with haltabgraf do begin
  xe:=keprex(xszor*(xkord[i]-xmin));
  ye:=keprey(yszor*(ykord[i]-ymin));
 end;
end;

{Az aktulis kpen lv X hol lenne a kezdkpen}
FUNCTION TRajzForm.KEPROLX(MIT:INTEGER):INTEGER;
var s : real;
BEGIN
 S:=(MIT-kepszele)/KEPSZORZO+KEPXMIN;
 KEPROLX:=ROUND(S);
END;

FUNCTION TRajzForm.KEPROLY(MIT:INTEGER):INTEGER;  {UGYANEZ AZ Y KOORD-VAL}
var s : real;
BEGIN
 S:=(maxy-MIT-kepszele)/KEPSZORZO+KEPYMIN;
 KEPROLY:=ROUND(S);
END;

procedure TRajzForm.keprolpont(xe,ye:integer;   {az xe,ye kppont eredeti}
                               var x,y:kord);   {koordintit x,y -ba    }
const t0=100;
var t,x1,y1:kord; x1e,y1e:integer;
    novo:boolean;
begin
 {kiindul pont}
 x:=round(keprolx(xe)/xszor+xmin);
 y:=round(keproly(ye)/yszor+ymin);
 {'rfkuszls'}
 {x}
 t:=t0; x1:=x+t; x1e:=keprex(xszor*(x1-xmin)); novo:=true;
 while (xe<>x1e) and (t>=1) do begin
  if novo then
   if x1e>xe then begin
    t:=t div 2; novo:=false;
    x1:=x1-t; x1e:=keprex(xszor*(x1-xmin));
   end else begin
    x1:=x1+t; x1e:=keprex(xszor*(x1-xmin));
   end
  else
   if x1e<xe then begin
    t:=t div 2; novo:=true;
    x1:=x1+t; x1e:=keprex(xszor*(x1-xmin));
   end else begin
    x1:=x1-t; x1e:=keprex(xszor*(x1-xmin));
   end;
 end;
 {y}
 t:=t0; y1:=y+t; y1e:=keprey(yszor*(y1-ymin)); novo:=true;
 while (ye<>y1e) and (t>=1) do begin
  if novo then
   if y1e<ye then begin {<:origo fent van}
    t:=t div 2; novo:=false;
    y1:=y1-t; y1e:=keprey(yszor*(y1-ymin));
   end else begin
    y1:=y1+t; y1e:=keprey(yszor*(y1-ymin));
   end
  else
   if y1e>ye then begin
    t:=t div 2; novo:=true;
    y1:=y1+t; y1e:=keprey(yszor*(y1-ymin));
   end else begin
    y1:=y1-t; y1e:=keprey(yszor*(y1-ymin));
   end;
 end;
 x:=x1; y:=y1;
end;

PROCEDURE TRajzForm.NAGYITAS(cim:string);
const ablakmin=5; {a kezdkpen lv nagyt ablak min. szlessge}
var i,j:integer;
begin
 with NagyitoKeret do
  if keprolx(jobbx)<=                     {Igen nagy nagyits esetre}
     keprolx(balx)+ablakmin
   then
    Uzen('Tl nagy nagyts!')
   else begin
    {az j rtkek}
    KEPXMAX:=KEPROLX(JOBBX);  KEPXMIN:=KEPROLX(BALX);
    KEPYMAX:=KEPROLY(FELSOY); KEPYMIN:=KEPROLY(ALSOY);
    KEPSZORZO:=(maxx-2*kepszele)/(KEPXMAX-KEPXMIN);
    {'vermels'}
    if aktnagy=maxnagy then begin
     {helyet ksztnk a tmbk vgn}
     for i:=2 to maxnagy do begin
      kepxmaxt[i-1]:=kepxmaxt[i];
      kepxmint[i-1]:=kepxmint[i];
      kepymaxt[i-1]:=kepymaxt[i];
      kepymint[i-1]:=kepymint[i];
      kepszorzot[i-1]:=kepszorzot[i];
     end;
    end else inc(aktnagy);  {befr mg}
    kepxmaxt[aktnagy]:=kepxmax;
    kepxmint[aktnagy]:=kepxmin;
    kepymaxt[aktnagy]:=kepymax;
    kepymint[aktnagy]:=kepymin;
    kepszorzot[aktnagy]:=kepszorzo;
    aktnagymax:=aktnagy; {eddig mehetnk majd 'elre'}
    {kirajzols}
    KEPRAJZOL;
    MenuBeallit;
   end;
end;

procedure TRajzForm.KepMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

 procedure KeretKezd;
  begin
   VanNagyitoKeret:=True;
   setlinestyle(psSolid,1);
   setfillstyle(Kep,1,hatterszin);
   setcolor(ablakszin);
   KezdoP:=Point(X,Y);
   MozgoP:=KezdoP;
  end;

var x0,x1,x2,y0,y1,y2:kord;
begin
 case Button of
  mbLeft:begin
   KiemLevesz;
   {Pontinformci}
   if AktFunkc='1_1' then begin
    pontkereses(x,y,PInd);
    TelepKiem1(true);
    PontInf;
   end else
   {linformci}
   if AktFunkc='1_2' then begin
    elkereses(x,y,KpInd,VpInd);
    SzakaszKiem1(true);
    SzakInf;
   end else
   {Nagyts}
   if AktFunkc='4_1' then begin
    KeretKezd;
   end;
  end;
 end;
end;

{A kijell keret csak jobbra lefel nhet s nem tud lelgni a Kep-rl}
procedure TRajzForm.KepMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var P,UjMozgoP:TPoint;
begin
 if AktFunkc='4_1' then begin
  {Nagytsnl a keret a Kep-el arnyos marad, viszont ekkor}
  {az egrkurzor elmszhat a nagytkeret jobb als sarktl}
  if VanNagyitoKeret then begin
   P:=Point(X,Y);
   if (P.X>KezdoP.X) and (P.Y>KezdoP.Y) and (P.X<Kep.Width) then begin
    UjMozgoP.X:=P.X;
    UjMozgoP.Y:=Round(KezdoP.Y+(P.X-KezdoP.X)*Kep.Height/Kep.Width);
    if UjMozgoP.Y<Kep.Height then begin
     NagyitoKeretRajz(KezdoP,MozgoP,pmNotXor);
     MozgoP:=UjMozgoP;
     NagyitoKeretRajz(KezdoP,MozgoP,pmNotXor);
    end;
   end;
  end;
 end;
end;

procedure TRajzForm.KepMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if AktFunkc='4_1' then
  if VanNagyitoKeret then begin
   VanNagyitoKeret:=false;
   NagyitoKeretRajz(KezdoP,MozgoP,pmNotXor);
   Kep.Canvas.Pen.Mode:=pmCopy; {mert pmNotXor volt}
   with NagyitoKeret do begin
    Balx:=KezdoP.X; Jobbx:=MozgoP.X;
    Alsoy:=MozgoP.Y; Felsoy:=KezdoP.Y;
   end;
   Nagyitas('');
   AktFunkcSet('','');
  end;
end;

procedure TRajzForm.NagyitoKeretRajz(BFP,JAP:TPoint; AktTollMod:TPenMode);
begin
 with Kep.Canvas do begin
  Pen.Mode:=AktTollMod;
  Rectangle(BFP.X,BFP.Y,JAP.X,JAP.Y);
 end;
end;

procedure TRajzForm.Bumzli(x,y,szin,szelesseg:integer);
var sugar:integer; elozo:TColor;
begin
 with Kep.Canvas do
  if szelesseg=1 then
   Pixels[x,y]:=szin
  else begin
   elozo:=Brush.Color;
   Brush.Color:=szin;
   sugar:=szelesseg div 2;
   FillRect(Rect(x-sugar,y-sugar,x+sugar,y+sugar));
   Brush.Color:=elozo;
  end;
end;

procedure TRajzForm.TelepKiem(i:pontind; szin,szelesseg:integer);
var x,y:integer;
begin
 keprepont(i,x,y);
 Bumzli(x,y,szin,szelesseg);
end;

procedure TRajzForm.SzakaszKiem(i,j:pontind; szin,szelesseg:integer);
begin
 keprepont(i,kpxe,kpye); keprepont(j,vpxe,vpye);
 with Kep.Canvas do begin
  Pen.Color:=szin;
  Pen.Width:=szelesseg;
  MoveTo(kpxe,kpye);
  LineTo(vpxe,vpye);
 end;
end;

procedure TRajzForm.TelepKiem1(Kiem:boolean);
begin
 if PInd>0 then
  if Kiem then begin     {Kiemels}
   with settings[1].telep[1] do
    TelepKiem(PInd,Szin,Szel);
   SzakaszKiem1(false);  {Ha pont igen akkor szakasz ne legyen kiemelve}
  end else begin         {Lemeszels}
   with settings[1].telep[2] do
    TelepKiem(PInd,Szin,Szel);
   PInd:=0;
  end;
end;

procedure TRajzForm.SzakaszKiem1(Kiem:boolean);
begin
 if (KpInd>0) and (VpInd>0) then
  if Kiem then begin     {Kiemels}
   with settings[2].vonal[1] do
    SzakaszKiem(KpInd,VpInd,Szin,Vast);
   TelepKiem1(false);   {Ha szakasz igen akkor pont ne legyen kiemelve}
  end else begin        {Lemeszels}
   with settings[2].vonal[2] do
    SzakaszKiem(KpInd,VpInd,Szin,Vast);
   KpInd:=0; VpInd:=0;
  end;
end;

procedure TRajzForm.KiemLevesz;
begin
 VanNagyitoKeret:=false;
 TelepKiem1(false);
 SzakaszKiem1(false);
end;

{A kpi. pontbl a vpi. pontba men l van legkzelebb (x0,y0)-hoz}
procedure TRajzForm.ElKereses(x0,y0:integer; var kpi,vpi:pontin0);
var m,x,y,t,t1,t2,t3,mint:real;
    x1,y1,x2,y2,i,j:integer;
    x0r,y0r,x1r,y1r,x2r,y2r:real;
begin
mint:=1E37; x0r:=x0; y0r:=y0;          {legalbb egy l van (lsd: szakasz)}
with haltabgraf do                               {gy legkzelebbi is van}
 for i:=1 to pontdb do
  begin
   keprepont(i,x1,y1);
   x1r:=x1; y1r:=y1;
   for j:=mut[i] to mut[i+1]-1 do
    begin
     keprepont(elvp[j],x2,y2);                         {(x,y): metszspont}
     x2r:=x2; y2r:=y2;
     if y1=y2
      then                                                     {vizszintes}
       begin
        t:=abs(y0r-y1r); x:=x0r; y:=y1r;           {koordintk klnbsge}
       end                                         { remljk nem szll el}
      else
       if x1=x2
        then                                                   {fggleges}
         begin
          t:=abs(x0r-x1r); x:=x1r; y:=y0r;
         end
        else                                                        {ferde}
         begin
          m:=y2r; m:=(m-y1r)/(x2r-x1r);
          x:=(x0r/m+m*x1r-y1r+y0r)/(m+1/m);
          y:=y0r-(x-x0r)/m;
          t:=sqrt(sqr(x-x0r)+sqr(y-y0r));
         end;
     t1:=sqrt(sqr(x1r-x2r)+sqr(y1r-y2r));                  {szakasz hossza}
     t2:=sqrt(sqr(x-x1r)+sqr(y-y1r));     {metszspont az egyik vgponttl}
     t3:=sqrt(sqr(x-x2r)+sqr(y-y2r));                  {a msik vgponttl}
     if (t2<=t1) and (t3<=t1)
      then              {(x,y) a szakaszra esik -> j a tvolsg          }
      else              {nem r esik -> szakaszvgpontoktl vesszk a t-t }
       begin
        t2:=sqrt(sqr(x0-x1r)+sqr(y0-y1r));    {(x0,y0) az egyik vgponttl}
        t3:=sqrt(sqr(x0-x2r)+sqr(y0-y2r));             {a msik vgponttl}
        if t2<t3 then t:=t2 else t:=t3;
       end;
     if t<mint then
      begin mint:=t; kpi:=i; vpi:=elvp[j]; end;
    end;
  end;
end;

{Az (X0,Y0) ponthoz legkzelebb es pontot}
procedure TRajzForm.PontKereses(x0,y0:integer; var pi:pontin0);
var tav,min:real;
    i:integer;
begin
 pi:=0;
 min:=1E+37;
 with haltabgraf do
  for i:=1 to pontdb do begin
   keprepont(i,kpxe,kpye);
   tav:=sqrt(sqr(x0-kpxe)+sqr(y0-kpye));
   if tav<min then begin
    min:=tav; pi:=i;
   end;
  end;
end;

{kpont.pontbl a vpont.pontba a haltabgraf hnyadik le fut}
function TRajzForm.elsorsz(kpont,vpont:pontind):elin0;
var i:integer;
begin
 elsorsz:=0;
 with haltabgraf do
  for i:=mut[kpont] to mut[kpont+1]-1 do
   if elvp[i]=vpont then elsorsz:=i;
end;

procedure TRajzForm.PontInf;
begin
 if PInd>0 then
  with haltabgraf do
   StatusBar1.Panels[1].Text:=
    'Pontazonost:'+pontaz[PInd]+'  '+
    'X:'+IntToStr(xkord[PInd])+'  '+
    'Y:'+IntToStr(ykord[PInd])+'  '+
    'Kimen lek szma:'+IntToStr(mut[PInd+1]-mut[PInd]);
end;

procedure TRajzForm.SzakInf;
begin
 if (KpInd>0) and (VpInd>0) then
  with haltabgraf do
   StatusBar1.Panels[1].Text:=
    'Kezdpont:'+trim(pontaz[KpInd])+'  '+
    'Vgpont:'+trim(pontaz[VpInd])+'  '+
    't:'+trim(Elut[elsorsz(KpInd,vpInd)]);
end;

{A menpontok elrhetsgt lltja be}
procedure TRajzForm.MenuBeallit;
begin
 {A Nagyits,Kezdkp,Vissza,Elre menpontokat csak}
 {maximalizlt ablak esetn engedjk}
 {Allapot-ban az akt. llapot van}
 mp4_1.Enabled:=Allapot=wsMaximized;
 mp4_2.Enabled:=(Allapot=wsMaximized) and (aktnagy>1);
 mp4_3.Enabled:=(Allapot=wsMaximized) and (aktnagy>1);
 mp4_4.Enabled:=(Allapot=wsMaximized) and (aktnagy<aktnagymax);
end;

procedure TRajzForm.AktFunkcSet(Funkcio,Felirat:string);
begin
 AktFunkc:=Funkcio;
 if (Funkcio='') and (Felirat='') then begin
  StatusBar1.Panels[0].Text:='';
  StatusBar1.Panels[1].Text:='';
  MenuBeallit;
 end else begin
  StatusBar1.Panels[0].Text:={Funkcio+':'+}Felirat;
  StatusBar1.Panels[1].Text:='';
 end;
end;

procedure TRajzForm.mpAltClick(Sender: TObject);
var s,o:integer; st,st1:string;
begin
 with Sender as TMenuItem do begin
  st:=SzamotSt(Name);
  Szamot(Name,s,o);
  case s of
   1:st1:=mp1.Caption+' '+Caption;
   4:st1:=mp4.Caption+' '+Caption;
  end;
  KiemKarTorol(st1);
 end;
 {A gyorsbillentys funkcik vgrehajtsa utn,}
 {az elz funkcit folytatjuk (ha volt)}
 if (st='4_2') or (st='4_3') or (st='4_4') then begin
  if st='4_2' then begin
   kezdokep;
  end else
  if st='4_3' then begin
   nagylep(false);
  end else
  if st='4_4' then begin
   nagylep(true);
  end;
 end else begin
  {Nem gyorsbillentys funkci - trjk az aktulis funkcit}
  AktFunkcSet(st,st1);
  if st='1_3' then begin
   close;
  end else
  {4_1-et a MouseDown-ban kezdjk}
  if AktFunkc='4_5' then begin
   TSettingForm.Create(Self).ShowModal;
   AktFunkcSet('','');
  end;
 end;
end;

{WindowState a mretezs eltti llapotot adja, s nem az j mrethez}
{tartoz llapotot, ezrt adminisztrljuk kln az ablak llapott}
procedure TRajzForm.FormResize(Sender: TObject);
begin
 {Az ablak mretek az j (mr mdostott) mretet adjk}
 if (Width=Tmaxx) and (Height=Tmaxy) then
  Allapot:=wsMaximized
 else
  Allapot:=wsNormal;
 MenuBeallit;
end;

{Megjegyzsek:
 - Az Image objektum alClient igaztsnl kitlti az ablakot.
   Scrollozni nem lehet, de a StatusBar mindig ltszdik.
   Ha a Picture.Graphic nagyobb mint a kperny, akkor a lelg rszeket
   nem lehet megnzni, ha kisebb, akkor meg rossz a helykihasznls.
   A nagyts lass, a nagytkeret megadsnl villog a kp.
 - Scrollozni, azaz egy kisebbre mretezett ablakban, a nem ltsz
   rszeket megnzni csak alNone igazts esetn lehet.
   Ekkor az ablak aljra tett statusbar is scrollozdik, gy az nem
   mindig ltszdik.
   A mretez segdablak (MeretU) alClient-el igaztott Image
   objektumnak szlessgnl legalbb 1-el kevesebbre kell lltani
   a szlessget, mert megjelennek a grgetsvok.
 - A mretezs a maximalizl gombbal is letilthat, ekkor a
   programbeli maximalizls a teljes kpernyre nyitja az ablakot,
   gy a tlct is eltakarja. Ilyenkor a mretez formon is tiltsuk le
   a maximalizl gombot, mert nem lesz sszhangban a kt ablak,
   s a kp nem tlti ki a teljes ablakot.
sszevetve:
 - Megengedjk az ablak mretezst, a kimarad rszekre val
   scrollozshoz alNone-al kell igaztunk az Image objektumot, gy
   a statusbar is scrollozdik.
 - A nagytsi funkcikat csak maximalizlt ablakban engedjk, mert
   kisebb ablak esetn zavar, hogy nem pont az nagytdik ki, amit
   a nagytkerettel kijelltnk}

procedure TRajzForm.FormCreate(Sender: TObject);
var BM:TBitMap; i,s,o,hib:integer; st:string;
    MeretForm:TRMeretForm;
begin
 {Mretbellts a teljes kpernys MeretForm segtsgvel}
 MeretForm:=TRMeretForm.Create(nil);
 MeretForm.Show;
 {A kep mreteit maxx,maxy-ba}
 {-1 nlkl bejn a vzszintes, s emiatt a fggleges grgetsv is}
 maxx:=MeretForm.Image1.Width-1;
 maxy:=MeretForm.Image1.Height;
 {Az ablak mreteit Tmaxx,Tmaxy-ba}
 Tmaxx:=MeretForm.Width;
 Tmaxy:=MeretForm.Height;
 {A MeretForm mr nem kell, felszabadtjuk}
 MeretForm.Free;
 {Form belltsok}
 {A Kep mrete}
 Kep.Width:=maxx;
 Kep.Height:=maxy;
 {A Picture.Graphic Kep mret legyen}
 BM:=TBitMap.Create;
 BM.Width:=maxx;
 BM.Height:=maxy;
 Kep.Picture.Graphic:=BM;
 {Kt panelt a StatusBar-ra}
 StatusBar1.Panels.Add;
 StatusBar1.Panels.Add;
 StatusBar1.Panels[0].Width:=150;
 {A szveg igaztsa az OutTextXY-hoz}
 AktHoriDir:=LeftText;
 AktVertDir:=TopText;
 {Rajzbelltsok (CfgDefault legyen a kezd bellts)}
 if not FileExists(CfgDefault) then begin
  AlapSettings(Settings);
  Fajlba(CfgDefault,Settings);
 end;
 SettingNev:=CfgDefault;
 Fajlbol(SettingNev,Settings);
 {Adatbeolvass, kirajzols}
 haltabepit;
 KezdoKep;
 {Teljes kpernys alakkal kezdjnk}
 WindowState:=wsMaximized;
 Allapot:=wsMaximized;
 MenuBeallit;
end;

end.

