{ Megjegyzsek:

  TApplication.HelpFile: a sg fjl.
   Egy sgfjl megadhat a Project/Options ablakban tervezskor is.
    Ebben az esetben az elrsi utat csak akkor hasznlja, ha az
    alkalmazst tartalmaz knyvtrban nem tallja a sgfjlt.
    Ekkor, a hibazenetben kirja a 'begetett' elrsi utat is!
   Tbb sg fjl esetn futskor kell belltani.
    Egy sgfjl esetn is clszer ezt futskor belltani,
    ahogyan a pldnkban is tettk.

  A sg direkt (nem az F1-el) behozsa:
   TApplication.HelpCommand : ltalnos hvs
   TApplication.HelpContext : egy adott tma behozsa sorszm alapjn
   TApplication.HelpJump    : egy adott tma behozsa azonost alapjn

  TApplication.OnHelp: a sg hvsakor lefut esemny.

  HelpContext: a megfelel tmakr hivatkoz sorszma (lsd: *.HPJ, Map) a
   TWinControl, TMenuItem, TPopupMenu, TCommonDialog objektumoknl.

   Ha 0, akkor rkldik a szl nem 0 HelpContext tulajdonsga
   (pl: Button1, TForm1 ill. mp1_4, mp1)

   Mivel a HelpContext alaprtelmezse 0, ezrt clszer a 0 sorszmmal
   egy olyan tmakrt definilni, amely a definilatlan HelpContext
   tulajdonsg Delphi elemek esetn jn majd be. }

unit HelpUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

const SugoFajlNev='Help.hlp';

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    mp1: TMenuItem;
     mp1_1: TMenuItem;
     mp1_2: TMenuItem;
     mp1_3: TMenuItem;
     N1: TMenuItem;
     mp1_4: TMenuItem;
    mp2: TMenuItem;
     mp2_1: TMenuItem;
     mp2_2: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button1: TButton;
    Button2: TButton;
    procedure mp1_4Click(Sender: TObject);
    procedure mp2_1Click(Sender: TObject);
    procedure mp2_2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TematBehoz(Sender: TObject);
  private
    { Private declarations }
    function HelpKezelo(Command: Word; Data: Longint;
                        var CallHelp: Boolean): Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.mp2_1Click(Sender: TObject);
begin
 {A tartalomjegyzket (Tartalom/Trgymutat/Keress flek) hozzuk be}
 Application.HelpCommand(HELP_FINDER,0);
 {A HelpCommand-ban hasznlt konstansokat (pl. HELP_FINDER)}
 {a Windows unit deklarlja, ott megnzhet a tbbi is de pl. a}
 {HELP_CONTENTS s a HELP_INDEX Delphi4, Win95 esetn nem mkdik}
end;

procedure TForm1.mp2_2Click(Sender: TObject);
begin
 {A sg hasznlata (uaz, mint a sgban lenyomott F1)}
 Application.HelpCommand(HELP_HELPONHELP,0);
end;

procedure TForm1.TematBehoz(Sender: TObject);
var tema:longint;
begin
 tema:=(Sender as TMenuItem).HelpContext;
 {A tema hivatkozsi sorszm tmakrt hozzuk be}
 Application.HelpCommand(HELP_CONTEXT,tema);
end;

procedure TForm1.mp1_4Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 {A ComboBox1-ben kivlasztott tmakrt a hivatkozsi szma alapjn}
 with ComboBox1 do
  Application.HelpContext(StrToInt(Items[ItemIndex]));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 {A ComboBox2-ben kivlasztott tmakrt az azonostja alapjn}
 with ComboBox2 do
  Application.HelpJump(Items[ItemIndex]);
end;

{Nem engedjk meg a Help hvst, hiszen nincs meg a Help fjl}
function TForm1.HelpKezelo(Command: Word; Data: Longint;
     var CallHelp: Boolean): Boolean;
begin
 CallHelp:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var st:string; VanHelp:boolean;
begin
 {Megvan-e a sg fjl (uott, ahol az alkalmazs)}
 st:=ExtractFilePath(Application.ExeName)+'\'+SugoFajlNev;
 VanHelp:=FileExists(st);
 if VanHelp then
  {Igen, engedjk a sgt}
  Application.HelpFile:=st
 else begin
  {Nincs meg a sg fjl, egyszer zennk s sajt Help kezelt}
  {lltunk be, ami nem csinl semmit (lenyeli a sg hvsokat}
  {azrt hogy lssunk pldt az OnHelp metdus hasznlatra is}
  MessageDlg('Nincs meg a sg fjl ('+SugoFajlNev+')!',
   mtError,[mbOK],0);
  Application.OnHelp:=HelpKezelo;
 end;
 {Az els vlaszthat ttelen kezdjnk}
 ComboBox1.ItemIndex:=0;
 ComboBox2.ItemIndex:=0;
end;

end.
