unit Csapat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Alap, Adatok;

type
  TfrmCsapat = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    btnRendben: TButton;
    btnMegsem: TButton;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;


implementation

{$R *.DFM}

procedure TfrmCsapat.btnRendbenClick(Sender: TObject);
var s:integer; van,kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   Edit1.Text:=Trim(Edit1.Text);
   if Edit1.Text='' then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    s:=dmAdatok.tblCsapat.FieldByName('Nv').Size;
    if length(Edit1.Text)>s then
     ShowMessage('A Nv mez maximum '+IntToStr(s)+' karakterbl llhat!')
    else begin
     {Van-e mr ilyen nev csapat}
     if Funkcio=idUj then begin
      van:=dmAdatok.tblCsapat.FindKey([Edit1.Text])
     end else begin
      s:=dmAdatok.tblCsapat.RecNo;
      van:=dmAdatok.tblCsapat.FindKey([Edit1.Text]) and
           (s<>dmAdatok.tblCsapat.RecNo);
      dmAdatok.tblCsapat.RecNo:=s;
     end;
     if van then
      ShowMessage('Van mr ilyen nev csapat!')
     else begin
      {Helyesek az adatok}
      if Funkcio=idUj then
       dmAdatok.tblCsapat.Append
      else
       dmAdatok.tblCsapat.Edit;
      dmAdatok.tblCsapat.FieldByName('Nv').AsString:=Edit1.Text;
      dmAdatok.tblCsapat.Post;
      kilep:=true;
     end;
    end;
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblCsapat.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Szerepel csoportbeosztsban)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmCsapat.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmCsapat.Create(AOwner:TComponent; AFunkcio:TMuvelet);
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 case Funkcio of
  idUj:begin
   Edit1.Text:='';
  end;
  idMod,idTor:begin
   Edit1.Text:=dmAdatok.tblCsapat.FieldByName('Nv').AsString;
   if Funkcio=idTor then begin
    Edit1.Enabled:=false;
   end;
  end;
 end;
end;

end.
