unit Csoport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Alap, Adatok, Nezeget;

type
  TfrmCsoport = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    btnRendben: TButton;
    btnMegsem: TButton;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;

implementation

{$R *.DFM}

procedure TfrmCsoport.btnRendbenClick(Sender: TObject);
var s:integer; van,kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   Edit1.Text:=Trim(Edit1.Text);
   if Edit1.Text='' then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    s:=dmAdatok.tblCsoport.FieldByName('Nv').Size;
    if length(Edit1.Text)>s then
     ShowMessage('A megnevezs maximum '+IntToStr(s)+' karakterbl llhat!')
    else begin
     {Van-e mr ilyen megnevezs csoport}
     if Funkcio=idUj then begin
      van:=dmAdatok.tblCsoport.Locate('Nv',Edit1.Text,[]);
     end else begin
      s:=dmAdatok.tblCsoport.RecNo;
      van:=dmAdatok.tblCsoport.Locate('Nv',Edit1.Text,[]) and
           (s<>dmAdatok.tblCsoport.RecNo);
      dmAdatok.tblCsoport.RecNo:=s;
     end;
     if van then
      ShowMessage('Van mr ilyen megnevezs csoport!')
     else begin
      {Helyesek az adatok}
      if Funkcio=idUj then
       dmAdatok.tblCsoport.Append
      else
       dmAdatok.tblCsoport.Edit;
      dmAdatok.tblCsoport.FieldByName('Nv').AsString:=Edit1.Text;
      dmAdatok.tblCsoport.FieldByName('vad').AsString:=AktEvad;
      dmAdatok.tblCsoport.FieldByName('Szezon').AsString:=AktSzezon;
      dmAdatok.tblCsoport.Post;
      kilep:=true;
     end;
    end; 
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblCsoport.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Van r hivatkozs)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmCsoport.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmCsoport.Create(AOwner:TComponent; AFunkcio:TMuvelet);
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 case Funkcio of
  idUj:begin
   Edit1.Text:='';
  end;
  idMod,idTor:begin
   Edit1.Text:=dmAdatok.tblCsoport.FieldByName('Nv').AsString;
   if Funkcio=idTor then begin
    Edit1.Enabled:=false;
   end;
  end;
 end;
end;

end.
