unit SZEKupa;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, DBTables, DB, StdCtrls, DBCtrls, Grids, DBGrids;

type
  TfrmFo = class(TForm)
    MainMenu1: TMainMenu;
    Csapatok1: TMenuItem;
    Jtkosok1: TMenuItem;
    Szak1: TMenuItem;
    N1: TMenuItem;
    vad1: TMenuItem;
    Szezonok1: TMenuItem;
    Pontozs1: TMenuItem;
    Bajnoksg1: TMenuItem;
    Alapadatok1: TMenuItem;
    miCsoportok: TMenuItem;
    miCsoportbeosztas: TMenuItem;
    miValasztas: TMenuItem;
    miOsszeallitas: TMenuItem;
    N2: TMenuItem;
    miEredmenyek: TMenuItem;
    miTabella: TMenuItem;
    Listzs1: TMenuItem;
    Csapatok2: TMenuItem;
    Jtkosok2: TMenuItem;
    procedure AlapadatKezelo(Sender: TObject);
    procedure BajnoksagKezelo(Sender: TObject);
    procedure ListazasKezelo(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    {res-e a Tabella tbla}
    UresTabella:boolean;
    procedure MenuBeallit;
    procedure BajnoksagBeallit;
    {A tabella tbla rekordjainak trlse}
    function TabellaTorol:boolean;
  public
    { Public declarations }
  end;

var
  frmFo: TfrmFo;

implementation

uses Alap, Adatok, Nezeget, Szak, Evad, Pontozas, Szezon,
     Jatekos, Csapat, Valasztas, Csoport, Csopbeo_Osszeall,
     Merkozes, Tabella, CsapatLista, JatekosLista;

{$R *.DFM}

procedure TfrmFo.MenuBeallit;
var VanCsop:boolean;
begin
 {A Bajnoksg almenpontjainak vlaszthatsga}
 if (AktEvad<>'') and (AktSzezon<>'') then begin
  {Van kivlasztott bajnoksg, a csoport tbla szrt}
  miCsoportok.Enabled:=true;
  miTabella.Enabled:=UresTabella;
  {Van-e mr felvve csoport}
  VanCsop:=dmAdatok.tblCsoport.RecordCount>0;
 end else begin
  miCsoportok.Enabled:=false;
  miTabella.Enabled:=false;
  VanCsop:=false;
 end;
 miCsoportbeosztas.Enabled:=VanCsop;
 miOsszeallitas.Enabled:=VanCsop;
 miEredmenyek.Enabled:=VanCsop;
end;

{Fejlcbe az aktulis bajnoksgot (vad, szezon)}
procedure TfrmFo.BajnoksagBeallit;
begin
 if (AktEvad<>'') and (AktSzezon<>'') then begin
  {Rllunk a megfelel rekordokra}
  dmAdatok.tblEvad.FindKey([AktEvad]);
  dmAdatok.tblSzezon.FindKey([AktSzezon]);
  {Fejlc}
  Caption:=Fejlec+' '+
   dmAdatok.tblEvad.FieldByName('v').AsString+' '+
   dmAdatok.tblSzezon.FieldByName('Nv').AsString;
  {Kt Master forrs nem hasznlhat (vad, Szezon), ezrt}
  {szrvel nyerjk ki a megfelel csoportrekordokat}
  dmAdatok.tblCsoport.Filter:='[vad]='+AktEvad+
   ' and [Szezon]='+AktSzezon;
  dmAdatok.tblCsoport.Filtered:=true;
 end else begin
  {Levesszk a csoportok szrst}
  dmAdatok.tblCsoport.Filtered:=false;
  Caption:=Fejlec;
 end;
 MenuBeallit;
end;

{Az Alapadatok menpont kezelshez}
procedure TfrmFo.AlapadatKezelo(Sender: TObject);
var r:integer; frmNezeget:TfrmNezeget;
    frmSzak:TfrmSzak; frmEvad:TfrmEvad;
    frmPontozas:TfrmPontozas; frmSzezon:TfrmSzezon;
    frmJatekos:TfrmJatekos; frmCsapat: TfrmCsapat;
    qry:TQuery;
begin
 case (Sender as TMenuItem).Tag of
  1:begin
     {Csapatok}
     dmAdatok.tblCsapat.IndexName:='Nvszerint';
     frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblCsapat,'Nv',
      'Csapatok',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       frmCsapat:=TfrmCsapat.Create(Self,r);
       frmCsapat.ShowModal;
       frmCsapat.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
     dmAdatok.tblCsapat.IndexName:='';
    end;
  2:begin
     {Jtkosok}
     {Lekrdezssel, hogy a szak rvidtseket lssuk}
     qry:=TQuery.Create(Self);
     qry.DatabaseName:=AliasNev;
     qry.sql.Add(
      'select jat.kd,jat.nv Nv,jat.kiegszts Kiegszts, '+
      ' sz.rvidts Szak '+
      'from jtkos jat,szak sz '+
      'where jat.szak=sz.kd '+
      'order by jat.nv,jat.kiegszts');
     qry.Open;
     {A kdot ne lssuk}
     qry.FieldByName('Kd').Visible:=false;
     frmNezeget:=TfrmNezeget.Create(Self,qry,'Nv','Jtkosok',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       if r in [idMod,idTor] then begin
        {Rllunk a megfelel jtkos rekordra}
        dmAdatok.tblJatekos.FindKey([qry.FieldByName('Kd').AsString]);
       end;
       frmJatekos:=TfrmJatekos.Create(Self,r);
       if frmJatekos.ShowModal=mrOk then begin
        {Frisstjk a lekrdezst (hogy lssuk a mdostst)}
        qry.Close;
        qry.Open;
        qry.FieldByName('Kd').Visible:=false;
        if r in [idUj,idMod] then
         {Rllunk az elbb felvett/mdostott rekordra}
         qry.Locate('Kd',dmAdatok.tblJatekos.FieldByName('Kd').AsString,[]);
       end;
       frmJatekos.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
     qry.Free;
    end;
  3:begin
     {vadok}
     {Lekrdezssel, hogy a pontozs neveket lssuk}
     qry:=TQuery.Create(Self);
     qry.DatabaseName:=AliasNev;
     {Az kezetes nevek megtrflhatnak, itt pl.}
     {az 'v' kis -vel rva nem mkdik jl!}
     qry.sql.Add(
      'select ev.kd,ev.v v,pont.nv Pontozs '+
      'from vad ev,pontozs pont '+
      'where ev.pontozs=pont.kd '+
      'order by ev.v');
     qry.Open;
     {A kdot ne lssuk}
     qry.FieldByName('Kd').Visible:=false;
     frmNezeget:=TfrmNezeget.Create(Self,qry,'v','vadok',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       if r in [idMod,idTor] then begin
        {Rllunk a megfelel vad rekordra}
        dmAdatok.tblEvad.FindKey([qry.FieldByName('Kd').AsString]);
       end;
       frmEvad:=TfrmEvad.Create(Self,r);
       if frmEvad.ShowModal=mrOk then begin
        {Frisstjk a lekrdezst (hogy lssuk a mdostst)}
        qry.Close;
        qry.Open;
        qry.FieldByName('Kd').Visible:=false;
        if r in [idUj,idMod] then
         {Rllunk az elbb felvett/mdostott rekordra}
         qry.Locate('Kd',dmAdatok.tblEvad.FieldByName('Kd').AsString,[]);
       end;
       frmEvad.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
     qry.Free;
     {Ha mdosult az aktulis vad}
     if AktEvad<>'' then begin
      if not dmAdatok.tblEvad.FindKey([AktEvad]) then begin
       {Kitrltk}
       AktEvad:=''; AktSzezon:='';
      end;
      BajnoksagBeallit;
     end;
    end;
  4:begin
     {Szezonok}
     frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblSzezon,'',
      'Szezonok',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       frmSzezon:=TfrmSzezon.Create(Self,r);
       frmSzezon.ShowModal;
       frmSzezon.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
     {Ha mdosult az aktulis szezon}
     if AktSzezon<>'' then begin
      if not dmAdatok.tblSzezon.FindKey([AktSzezon]) then begin
       {Kitrltk}
       AktEvad:=''; AktSzezon:='';
      end;
      BajnoksagBeallit;
     end;
    end;
  5:begin
     {Szakok}
     dmAdatok.tblSzak.IndexName:='Nvszerint';
     frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblSzak,'Nv',
      'Szakok',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       frmSzak:=TfrmSzak.Create(Self,r);
       frmSzak.ShowModal;
       frmSzak.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
     dmAdatok.tblSzak.IndexName:='';
    end;
  6:begin
     {Pontozs}
     frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblPontozas,'',
      'Pontozs',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       frmPontozas:=TfrmPontozas.Create(Self,r);
       frmPontozas.ShowModal;
       frmPontozas.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
    end;
 end;
end;

{Tabella tbla sszes rekordjnak trlse}
function TfrmFo.TabellaTorol:boolean;
var ok:boolean;
begin
 {Megprbljuk kitrlni a tabella tbla sszes rekordjt}
 with dmAdatok.tblTabella do begin
  ok:=true;
  First;
  while not Eof and ok do begin
   try
    Delete;
   except
    ShowMessage('A tabella tblt ms is hasznlja!');
    ok:=false;
   end;
  end;
 end;
 Result:=ok;
end;

{A Bajnoksg menpont kezelshez}
procedure TfrmFo.BajnoksagKezelo(Sender: TObject);
var r:integer; frmNezeget:TfrmNezeget;
    frmCsoport:TfrmCsoport; 
    frmTabella:TfrmTabella;
begin
 case (Sender as TMenuItem).Tag of
  1:begin
     {Vlaszts}
     TfrmValasztas.Create(Self).ShowModal;
     BajnoksagBeallit;
    end;
  2:begin
     {Csoportok}
     dmAdatok.tblCsoport.IndexName:='Nvszerint';
     frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblCsoport,'Nv',
      'Csoportok',idMVal);
     repeat
      r:=frmNezeget.ShowModal;
      if r in [idUj,idMod,idTor] then begin
       frmCsoport:=TfrmCsoport.Create(Self,r);
       frmCsoport.ShowModal;
       frmCsoport.Free;
      end;
     until r=mrCancel;
     frmNezeget.Free;
     dmAdatok.tblCsoport.IndexName:='';
     {A csoportok szmtl fgg menpontok vlaszthatsgrt}
     MenuBeallit;
    end;
  3:begin
     {Csoportbeoszts}
     TfrmCsopbeo_Osszeall.Create(Self,false).ShowModal;
    end;
  4:begin
     {Csapatsszellts}
     TfrmCsopbeo_Osszeall.Create(Self,true).ShowModal;
    end;
  5:begin
     {Eredmnyek}
     TfrmMerkozes.Create(Self).ShowModal;
    end;
  6:begin
     {Tabella}
     frmTabella:=TfrmTabella.Create(Self);
     {A Preview ablak fejlcben lssuk az aktulis bajnoksgot}
     frmTabella.QuickRep1.ReportTitle:=Caption;
     {A jelents cmben is jelenjen ez meg}
     frmTabella.QR_Cim.Caption:=Caption+' Tabella';
     {A jelents megmutatsa}
     frmTabella.QuickRep1.PreviewModal;
     frmTabella.Free;
     {A tabella tbla rekordjainak trlse}
     UresTabella:=TabellaTorol;
     {A Tabella menpont vlaszthatsgrt}
     MenuBeallit;
    end;
 end;
end;

{A Listzs menpont kezelshez}
procedure TfrmFo.ListazasKezelo(Sender: TObject);
var frmCsapatLista:TfrmCsapatLista;
    frmJatekosLista:TfrmJatekosLista;
begin
 case (Sender as TMenuItem).Tag of
  1:begin
     {Csapatok listzsa}
     frmCsapatLista:=TfrmCsapatLista.Create(Self);
     {A Preview ablak fejlce}
     frmCsapatLista.QuickRep1.ReportTitle:=TMenuItem(Sender).Caption;
     {A jelents megmutatsa}
     frmCsapatLista.QuickRep1.PreviewModal;
     frmCsapatLista.Free;
    end;
  2:begin
     {Jtkosok listzsa}
     frmJatekosLista:=TfrmJatekosLista.Create(Self);
     {A Preview ablak fejlce}
     frmJatekosLista.QuickRep1.ReportTitle:=TMenuItem(Sender).Caption;
     {A jelents megmutatsa}
     frmJatekosLista.QuickRep1.Preview;
     frmJatekosLista.Free;
    end;
 end;
end;

procedure TfrmFo.FormCreate(Sender: TObject);
var f:TextFile;
begin
 {A hasznlatos tblk nyitsa}
 dmAdatok.tblPontozas.Open;
 dmAdatok.tblSzak.Open;
 dmAdatok.tblSzezon.Open;
 dmAdatok.tblEvad.Open;
 dmAdatok.tblJatekos.Open;
 dmAdatok.tblCsapat.Open;
 dmAdatok.tblCsoport.Open;
 dmAdatok.tblCsoportbeosztas.Open;
 dmAdatok.tblOsszeallitas.Open;
 dmAdatok.tblMerkozes.Open;
 dmAdatok.tblTabella.Open;
 {A tabella tbla rekordjainak trlse}
 UresTabella:=TabellaTorol;
 {A kdokat ne lssuk}
 dmAdatok.tblPontozas.FieldByName('Kd').Visible:=false;
 dmAdatok.tblSzak.FieldByName('Kd').Visible:=false;
 dmAdatok.tblSzezon.FieldByName('Kd').Visible:=false;
 dmAdatok.tblEvad.FieldByName('Kd').Visible:=false;
 dmAdatok.tblEvad.FieldByName('Pontozs').Visible:=false;
 dmAdatok.tblJatekos.FieldByName('Kd').Visible:=false;
 dmAdatok.tblCsapat.FieldByName('Kd').Visible:=false;
 dmAdatok.tblCsoport.FieldByName('Kd').Visible:=false;
 dmAdatok.tblCsoport.FieldByName('vad').Visible:=false;
 dmAdatok.tblCsoport.FieldByName('Szezon').Visible:=false;
 {Az aktulis bajnoksg betltse}
 if FileExists(AktBajnoksag) then begin
  AssignFile(f,AktBajnoksag);
  Reset(f);
  ReadLn(f,AktEvad); ReadLn(f,AktSzezon);
  CloseFile(f);
 end;
 BajnoksagBeallit;
end;

procedure TfrmFo.FormClose(Sender: TObject; var Action: TCloseAction);
var f:TextFile;
begin
 {A hasznlatos tblk zrsa}
 dmAdatok.tblPontozas.Close;
 dmAdatok.tblSzak.Close;
 dmAdatok.tblSzezon.Close;
 dmAdatok.tblEvad.Close;
 dmAdatok.tblJatekos.Close;
 dmAdatok.tblCsapat.Close;
 dmAdatok.tblCsoport.Close;
 dmAdatok.tblCsoportbeosztas.Close;
 dmAdatok.tblOsszeallitas.Close;
 dmAdatok.tblMerkozes.Close;
 dmAdatok.tblTabella.Close;
 {Az aktulis bajnoksg elmentse}
 AssignFile(f,AktBajnoksag);
 ReWrite(f);
 WriteLn(f,AktEvad); WriteLn(f,AktSzezon);
 CloseFile(f);
end;

end.

