unit Szak;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Alap, Adatok;

type
  TfrmSzak = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    btnRendben: TButton;
    btnMegsem: TButton;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;

implementation

{$R *.DFM}

procedure TfrmSzak.btnRendbenClick(Sender: TObject);
var s:integer; kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   Edit1.Text:=Trim(Edit1.Text);
   Edit2.Text:=Trim(Edit2.Text);
   if (Edit1.Text='') or (Edit2.Text='') then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    s:=dmAdatok.tblSzak.FieldByName('Nv').Size;
    if length(Edit1.Text)>s then
     ShowMessage('A Nv mez maximum '+IntToStr(s)+' karakterbl llhat!')
    else begin
     s:=dmAdatok.tblSzak.FieldByName('Rvidts').Size;
     if length(Edit2.Text)>s then
      ShowMessage('A Rvidts mez maximum '+IntToStr(s)+' karakterbl llhat!')
     else begin
      {Helyesek az adatok}
      if Funkcio=idUj then
       dmAdatok.tblSzak.Append
      else
       dmAdatok.tblSzak.Edit;
      dmAdatok.tblSzak.FieldByName('Nv').AsString:=Edit1.Text;
      dmAdatok.tblSzak.FieldByName('Rvidts').AsString:=Edit2.Text;
      dmAdatok.tblSzak.Post;
      kilep:=true;
     end;
    end;
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblSzak.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Van ilyen szakos jtkos)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmSzak.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmSzak.Create(AOwner:TComponent; AFunkcio:TMuvelet);
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 case Funkcio of
  idUj:begin
   Edit1.Text:=''; Edit2.Text:='';
  end;
  idMod,idTor:begin
   Edit1.Text:=dmAdatok.tblSzak.FieldByName('Nv').AsString;
   Edit2.Text:=dmAdatok.tblSzak.FieldByName('Rvidts').AsString;
   if Funkcio=idTor then begin
    Edit1.Enabled:=false; Edit2.Enabled:=false;
   end;
  end;
 end;
end;

end.
