unit Szezon;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Alap, Adatok;

type
  TfrmSzezon = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    btnRendben: TButton;
    btnMegsem: TButton;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;


implementation

{$R *.DFM}

procedure TfrmSzezon.btnRendbenClick(Sender: TObject);
var s:integer; van,kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   Edit1.Text:=Trim(Edit1.Text);
   if Edit1.Text='' then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    s:=dmAdatok.tblSzezon.FieldByName('Nv').Size;
    if length(Edit1.Text)>s then
     ShowMessage('A Nv mez maximum '+IntToStr(s)+' karakterbl llhat!')
    else begin
     {Van-e mr ilyen nev szezon}
     s:=dmAdatok.tblSzezon.RecNo;
     {Locate-el, mert nem hasznlunk nv szerinti indexet}
     van:=dmAdatok.tblSzezon.Locate('Nv',Edit1.Text,[]) and
          (s<>dmAdatok.tblSzezon.RecNo);
     dmAdatok.tblSzezon.RecNo:=s;
     if van then
      ShowMessage('Van mr ilyen nev szezon!')
     else begin
      {Helyesek az adatok}
      if Funkcio=idUj then
       dmAdatok.tblSzezon.Append
      else
       dmAdatok.tblSzezon.Edit;
      dmAdatok.tblSzezon.FieldByName('Nv').AsString:=Edit1.Text;
      dmAdatok.tblSzezon.Post;
      kilep:=true;
     end;
    end;
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblSzezon.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Van ilyen szezon csoport)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmSzezon.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmSzezon.Create(AOwner:TComponent; AFunkcio:TMuvelet);
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 case Funkcio of
  idUj:begin
   Edit1.Text:='';
  end;
  idMod,idTor:begin
   Edit1.Text:=dmAdatok.tblSzezon.FieldByName('Nv').AsString;
   if Funkcio=idTor then begin
    Edit1.Enabled:=false;
   end;
  end;
 end;
end;


end.
