unit Valasztas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Alap, Adatok, Nezeget, StdCtrls;

type
  TfrmValasztas = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    btnEvad: TButton;
    btnSzezon: TButton;
    btnRendben: TButton;
    btnMegsem: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
    procedure btnEvadClick(Sender: TObject);
    procedure btnSzezonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    {Az aktulisan kivlasztott vad s szezon kdok}
    EvadKod,SzezonKod:string;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TfrmValasztas.btnRendbenClick(Sender: TObject);
var kilep:boolean;
begin
 kilep:=false;
 {Adatellenrzs}
 if (Edit1.Text='') or (Edit2.Text='') then
  ShowMessage('Hinyos/hinyz adatok!')
 else begin
  {Helyesek az adatok}
  AktEvad:=EvadKod;
  AktSzezon:=SzezonKod;
  kilep:=true;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmValasztas.btnEvadClick(Sender: TObject);
var frmNezeget:TfrmNezeget;
begin
 if EvadKod='' then
  {Az els vad rekordra llunk}
  dmAdatok.tblEvad.First
 else
  {Rllunk a megfelel vad rekordra}
  dmAdatok.tblEvad.FindKey([EvadKod]);
 {Vlaszthat vad rekordot}
 frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblEvad,'v',
  'vad vlaszts',idRVal);
 if frmNezeget.ShowModal=idRVal then begin
  EvadKod:=dmAdatok.tblEvad.FieldByName('Kd').AsString;
  Edit1.Text:=dmAdatok.tblEvad.FieldByName('v').AsString;
 end;
 frmNezeget.Free;
end;

procedure TfrmValasztas.btnSzezonClick(Sender: TObject);
var frmNezeget:TfrmNezeget;
begin
 if SzezonKod='' then
  {Az els szezon rekordra llunk}
  dmAdatok.tblSzezon.First
 else
  {Rllunk a megfelel szezon rekordra}
  dmAdatok.tblSzezon.FindKey([SzezonKod]);
 {Vlaszthat szezon rekordot}
 frmNezeget:=TfrmNezeget.Create(Self,dmAdatok.tblSzezon,'',
  'Szezon vlaszts',idRVal);
 if frmNezeget.ShowModal=idRVal then begin
  SzezonKod:=dmAdatok.tblSzezon.FieldByName('Kd').AsString;
  Edit2.Text:=dmAdatok.tblSzezon.FieldByName('Nv').AsString;
 end;
 frmNezeget.Free;
end;

procedure TfrmValasztas.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

procedure TfrmValasztas.FormCreate(Sender: TObject);
begin
 Caption:='vad-Szezon vlaszts';
 if (AktEvad='') or (AktSzezon='') then begin
  EvadKod:=''; SzezonKod:='';
 end else begin
  EvadKod:=AktEvad; SzezonKod:=AktSzezon;
  {A megfelel adatokat a vezrlkbe}
  dmAdatok.tblEvad.FindKey([EvadKod]);
  Edit1.Text:=dmAdatok.tblEvad.FieldByName('v').AsString;
  dmAdatok.tblSzezon.FindKey([SzezonKod]);
  Edit2.Text:=dmAdatok.tblSzezon.FieldByName('Nv').AsString;
 end;
end;

procedure TfrmValasztas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Action:=caFree;
end;

end.
