unit Keret;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus;

type
  TKeretForm = class(TForm)
    MainMenu1: TMainMenu;
    Fajl: TMenuItem;
    Uj: TMenuItem;
    Megnyitas: TMenuItem;
    N1: TMenuItem;
    Kilepes: TMenuItem;
    Ablak: TMenuItem;
    VizszintesMozaikElrendezes: TMenuItem;
    LepcsosElrendezes: TMenuItem;
    IkonokElrendezese: TMenuItem;
    FuggolegesMozaikElrendezes: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure UjClick(Sender: TObject);
    procedure KilepesClick(Sender: TObject);
    procedure VizszintesMozaikElrendezesClick(Sender: TObject);
    procedure FuggolegesMozaikElrendezesClick(Sender: TObject);
    procedure LepcsosElrendezesClick(Sender: TObject);
    procedure IkonokElrendezeseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MegnyitasClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  KeretForm: TKeretForm;

implementation

uses Gyerek;

{$R *.DFM}

procedure TKeretForm.UjClick(Sender: TObject);
begin
 TGyerekForm.Create(Self);
end;

procedure TKeretForm.KilepesClick(Sender: TObject);
begin
 Close;
end;

procedure TKeretForm.VizszintesMozaikElrendezesClick(Sender: TObject);
begin
 TileMode:=tbHorizontal;
 Tile;
end;

procedure TKeretForm.FuggolegesMozaikElrendezesClick(Sender: TObject);
begin
 TileMode:=tbVertical;
 Tile;
end;

procedure TKeretForm.LepcsosElrendezesClick(Sender: TObject);
begin
 Cascade;
end;

procedure TKeretForm.IkonokElrendezeseClick(Sender: TObject);
begin
 ArrangeIcons;
end;

procedure TKeretForm.FormShow(Sender: TObject);
begin
 UjClick(Sender);
end;

procedure TKeretForm.MegnyitasClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
  TGyerekForm.Create(Self).Megnyit(OpenDialog1.FileName);
end;

end.
