unit Ukep;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Mask, Spin, Clipbrd, ComCtrls;

type
  TFkep = class(TForm)
    Okgomb: TBitBtn;
    Cancelgomb: TBitBtn;
    RadioGroup1: TRadioGroup;
    R1: TRadioButton;
    R2: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Oszlop: TSpinEdit;
    Sor: TSpinEdit;
    Alapgomb: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure CancelgombClick(Sender: TObject);
    procedure AlapgombClick(Sender: TObject);
    procedure R2Click(Sender: TObject);
    procedure R1Click(Sender: TObject);
    procedure OszlopChange(Sender: TObject);
    procedure SorChange(Sender: TObject);
    procedure OkgombClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

    procedure Kepkiment;

var
  Fkep: TFkep;
  sorpixel,oszloppixel: integer;
  sorcm,oszlopcm: word;

implementation

uses Udipi;

{$R *.DFM}

procedure Kepkiment;
begin
  if Clipboard.HasFormat(CF_BITMAP) then
  with foform do
  begin
    BM:=TBitmap.Create;
    try
      BM.Assign(Clipboard); Vagolap.Picture.Graphic:=BM;
      with Vagolap do
        begin width:=BM.width; height:=BM.height; end;
      Vagolap.Canvas.Draw(0,0,Bm);
    finally Bm.Free; end;
  end;
  with Foform do
    begin
      Visszavonas.enabled:=true;  Visszavon.enabled:=true;
      Ujra.Enabled:=false;        Ismet.Enabled:=false;
      try
        Clipboard.Open; Clipboard.Assign(Kep.Picture);
        Skep1.Picture.Assign(Clipboard);
      finally
        Clipboard.Close;
      end;
    end;
  if Foform.kimasolva then Clipboard.Assign(Foform.Vagolap.Picture);
end;

procedure TFkep.FormActivate(Sender: TObject);
begin
  R2.checked:=true;
  sorpixel:=Foform.Kep.height;  oszloppixel:=Foform.Kep.width;
  sorcm:=sorpixel div 25;       oszlopcm:=oszloppixel div 25;
  Oszlop.Value:=oszloppixel;    Sor.Value:=sorpixel;
end;

procedure TFkep.CancelgombClick(Sender: TObject);
begin
  Close;
end;

procedure TFkep.AlapgombClick(Sender: TObject);
begin
  sorpixel:=250;           oszloppixel:=250;
  sorcm:=sorpixel div 25;  oszlopcm:=oszloppixel div 25;
  if R1.checked then
    begin Oszlop.Value:=oszlopcm; Sor.Value:=sorcm;  end
    else
      begin Oszlop.Value:=oszloppixel; Sor.Value:=sorpixel; end;
end;

procedure TFkep.R2Click(Sender: TObject);
begin
  sorpixel:=sorcm*25;         oszloppixel:=oszlopcm*25;
  Oszlop.Value:=oszloppixel;  Sor.Value:=sorpixel;
end;

procedure TFkep.R1Click(Sender: TObject);
begin
  sorcm:=sorpixel div 25;  oszlopcm:=oszloppixel div 25;
  Oszlop.Value:=oszlopcm;  Sor.Value:=sorcm;
end;

procedure TFkep.OszlopChange(Sender: TObject);
begin
  if R1.checked then
    begin
      if Oszlop.Value>32 then Oszlop.value:=32;
      oszlopcm:=Oszlop.Value; oszloppixel:=oszlopcm*25;
    end
    else oszloppixel:=Oszlop.Value;
end;

procedure TFkep.SorChange(Sender: TObject);
begin
  if R1.checked then
    begin
      if Sor.Value>24 then Sor.value:=24;
      sorcm:=Sor.Value;   sorpixel:=sorcm*25; end
    else sorpixel:=Sor.Value;
end;

procedure TFkep.OkgombClick(Sender: TObject);
begin
  with Foform do
    begin
      eloszin:=Kep.Canvas.Pen.Color; hatszin:=Kep.Canvas.Brush.Color;
      Kepkiment;      mentve:=false;
      Clipboard.Assign(Kep.Picture);
      BM:=TBitMap.Create;
      with BM do
        begin Width:=oszloppixel; Height:=sorpixel; end;
      Kep.Picture.Graphic:=BM;
      if Clipboard.HasFormat(CF_BITMAP) then
        begin
          BM := TBitmap.Create;
          try
            BM.Assign(Clipboard);  Kep.Canvas.Draw(0, 0, BM);
          finally BM.Free end;
        end;
      Kep.Canvas.Pen.Color:=eloszin; Kep.Canvas.Brush.Color:=hatszin;
      with Kep.Canvas.Cliprect do
        begin
          Meretfuggoleges.width:=right; Meretfuggoleges.top:=bottom;
          Meretvizszintes.left:=right;  Meretvizszintes.height:=bottom;
          Meretfv.left:=right;          Meretfv.top:=bottom;
          xnov:=right;                  ynov:=bottom;
        end;
    end;  
  if Foform.kimasolva then Clipboard.Assign(Foform.Vagolap.Picture);
end;

end.
