unit Utukroz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Clipbrd ;

type
  TFtukroz = class(TForm)
    RadioGroup1: TRadioGroup;
    Okgomb: TBitBtn;
    Cancelgomb: TBitBtn;
    R1: TRadioButton;
    R2: TRadioButton;
    procedure OkgombClick(Sender: TObject);
    procedure CancelgombClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

      procedure Kepkiment;

var
  Ftukroz: TFtukroz;

implementation

uses Udipi;

{$R *.DFM}

procedure Kepkiment;
begin
  if Clipboard.HasFormat(CF_BITMAP) then
  with foform do
  begin
    BM:=TBitmap.Create;
    try
      BM.Assign(Clipboard); Vagolap.Picture.Graphic:=BM;
      with Vagolap do
        begin width:=BM.width; height:=BM.height; end;
      Vagolap.Canvas.Draw(0,0,Bm);
    finally Bm.Free; end;
  end;
  with Foform do
    begin
{      Visszavonas.enabled:=true;  Visszavon.enabled:=true;
      Ujra.Enabled:=false;        Ismet.Enabled:=false;}
      try
        Clipboard.Open; Clipboard.Assign(Kep.Picture);
        Skep1.Picture.Assign(Clipboard);
      finally
        Clipboard.Close;
      end;
    end;
  if Foform.kimasolva then Clipboard.Assign(Foform.Vagolap.Picture);
end;

procedure TFtukroz.OkgombClick(Sender: TObject);
var i,j,fele,tav: longint;
    cs: integer;
begin
  with foform do
    begin
      Kepkiment;      Kep.Canvas.Pen.Mode:=pmCopy;
      if R1.checked then
        begin
          fele:=kivagbfy+(kivagjay-kivagbfy) div 2;
          for i:=kivagbfx+1 to kivagjax-1 do
            begin
              tav:=kivagjay-kivagbfy;
              for j:=kivagbfy+1 to fele do
                begin
                  cs:=Kep.Canvas.Pixels[i,j];
                  Kep.Canvas.Pixels[i,j]:=Kep.Canvas.Pixels[i,kivagbfy+tav];
                  Kep.Canvas.Pixels[i,kivagbfy+tav]:=cs;
                  dec(tav);
                  end;
            end;
        end
        else
          begin
            fele:=kivagbfx+(kivagjax-kivagbfx) div 2;
            tav:=kivagjax-kivagbfx-1;
            for i:=kivagbfx+1 to fele do
              begin
                for j:=kivagbfy to kivagjay-1 do
                  begin
                    cs:=Kep.Canvas.Pixels[i,j];
                    Kep.Canvas.Pixels[i,j]:=Kep.Canvas.Pixels[kivagbfx+tav,j];
                    Kep.Canvas.Pixels[kivagbfx+tav,j]:=cs;
                  end;
                dec(tav);
              end;
          end;
   end;
end;

procedure TFtukroz.CancelgombClick(Sender: TObject);
begin
  Close;
end;

end.
