unit Bekero;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  Jelek=set of char;
  JoJelekMetodus=function(Szoveg:string):Jelek of object;

  TBekero = class(TCustomEdit)
  private
    { Private declarations }
    FJoJelek:JoJelekMetodus;
    procedure Alaphelyzet;
  protected
    { Protected declarations }
    {A BackSpace-es javtst 'felrg' metdusok fellrsa}
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure MouseDown(Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer); override;
    procedure Click; override;
    procedure MouseUp(Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X,
      Y: Integer); override;
    procedure DoEnter; override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
  published
    { Published declarations }
    {A TabOrder lthatsgt 'nveljk', hogy ez is bellthat}
    {legyen a hv krnyezetben, az Object Inspector-ban}
    property TabOrder;
    {Az FJoJelek metdus tpus adatmez elrshez}
    property JoJelek:JoJelekMetodus read FJoJelek write FJoJElek;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TBekero]);
end;

{Ne legyen kijellt szveg, a cursort a szveg vgre}
procedure TBekero.Alaphelyzet;
begin
 SelLength:=0;
 SelStart:=Length(Text);
end;

{A vk kdok a Windows unit-ban deklarldnak}
procedure TBekero.KeyDown(var Key: Word; Shift: TShiftState);
begin
 {A kurzor mozgs s a Shift+Insert beszrs letiltsa}
 if (Key in [vk_left,vk_home,vk_up,vk_insert]) then Key:=0;
end;

procedure TBekero.KeyPress(var Key: Char);
begin
 {A Ctrl+V beilleszts letiltsa}
 if Key in [#22] then Key:=#0;
 {A nem j karakterek kiszrse (ha definilt a Jojelek)}
 if Assigned(JoJelek) then
  if not (Key in JoJelek(Text)) then Key:=#0;
end;

procedure TBekero.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Alaphelyzet;
end;

procedure TBekero.Click;
begin
 Alaphelyzet;
end;

procedure TBekero.MouseUp(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Alaphelyzet;
end;

procedure TBekero.MouseMove(Shift: TShiftState; X,Y: Integer);
begin
 Alaphelyzet;
end;

procedure TBekero.DoEnter;
begin
 Alaphelyzet;
end;

constructor TBekero.Create(AOwner:TComponent);
var pm:TPopupMenu;
begin
 {Az rklt Create meghvsa}
 inherited Create(AOwner);
 {A jobb egrgomb 'letiltsa'}
 pm:=TPopupMenu.Create(Self);
 pm.AutoPopup:=false;
 PopupMenu:=pm;
end;

end.

