unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Bekero;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Bekero1: TBekero;
    Bekero2: TBekero;
    function RendszamJoJelek(Rendszam:string):Jelek;
    function RendszamMegvan(Rendszam:string):boolean;
    function LottoszamJoJelek(Lottoszam:string):Jelek;
    function LottoszamMegvan(Lottoszam:string):boolean;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{Az elfogadhat karakterek belltsa rendszm esetn}
function TForm1.RendszamJoJelek(Rendszam:string):Jelek;
begin
 case length(Rendszam) of
  0..2:Result:=['A'..'Z'];
  3..4:Result:=['0'..'9'];
  5:begin
     if Copy(Rendszam,4,2)='00' then
      Result:=['1'..'9']
     else
      Result:=['0'..'9'];
    end;
  else Result:=[];
 end;
 {Backspace}
 if length(Rendszam)>0 then
  Result:=Result+[chr(vk_back)];
end;

{Rendszm tartalmi ellenrzs}
function TForm1.RendszamMegvan(Rendszam:string):boolean;
begin
 if length(Rendszam)<6 then begin
  ShowMessage('Hinyz rendszm karakterek!');
  Result:=false;
 end else
  Result:=true;
end;

{Az elfogadhat karakterek belltsa (5-s) lottszm esetn}
function TForm1.LottoszamJoJelek(Lottoszam:string):Jelek;
begin
 case length(Lottoszam) of
  0:Result:=['1'..'9'];
  1:begin
     if Lottoszam[1]='9' then
      Result:=['0']
     else
      Result:=['0'..'9'];
    end;
  else Result:=[];
 end;
 {Backspace}
 if length(Lottoszam)>0 then
  Result:=Result+[chr(vk_back)];
end;

{Lottoszm tartalmi ellenrzs}
function TForm1.LottoszamMegvan(Lottoszam:string):boolean;
begin
 if length(Lottoszam)=0 then begin
  ShowMessage('Hinyz lottszm!');
  Result:=false;
 end else
  Result:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if RendszamMegvan(Bekero1.Text) and
   LottoszamMegvan(Bekero2.Text) then
 ShowMessage('Megvannak (helyesek) az adatok!');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Close;
end;

end.
 