unit Pontozas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Alap, Adatok;

type
  TfrmPontozas = class(TForm)
    btnRendben: TButton;
    btnMegsem: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Label4: TLabel;
    Edit1: TEdit;
    procedure btnRendbenClick(Sender: TObject);
    procedure btnMegsemClick(Sender: TObject);
  private
    { Private declarations }
    Funkcio:TMuvelet;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent; AFunkcio:TMuvelet);
  end;

implementation

{$R *.DFM}

procedure TfrmPontozas.btnRendbenClick(Sender: TObject);
var s:integer; van,kilep:boolean;
begin
 case Funkcio of
  idUj,idMod:begin
   kilep:=false;
   {Adatellenrzs}
   if (Edit1.Text='') or (ComboBox1.Text='') or
      (ComboBox2.Text='') or (ComboBox3.Text='') then
    ShowMessage('Hinyos/hinyz adatok!')
   else begin
    s:=dmAdatok.tblPontozas.FieldByName('Nv').Size;
    if length(Edit1.Text)>s then
     ShowMessage('A Nv mez maximum '+IntToStr(s)+' karakterbl llhat!')
    else begin
     {Van-e mr ilyen nev pontozs}
     s:=dmAdatok.tblPontozas.RecNo;
     {Locate-el, mert nem hasznlunk nv szerinti indexet}
     van:=dmAdatok.tblPontozas.Locate('Nv',Edit1.Text,[]) and
          (s<>dmAdatok.tblPontozas.RecNo);
     dmAdatok.tblPontozas.RecNo:=s;
     if van then
      ShowMessage('Van mr ilyen nev pontozs!')
     else begin
      {Helyesek az adatok}
      if Funkcio=idUj then
       dmAdatok.tblPontozas.Append
      else
       dmAdatok.tblPontozas.Edit;
      dmAdatok.tblPontozas.FieldByName('Nv').AsString:=Edit1.Text;
      dmAdatok.tblPontozas.FieldByName('Gyzelem').AsString:=ComboBox1.Text;
      dmAdatok.tblPontozas.FieldByName('Dntetlen').AsString:=ComboBox2.Text;
      dmAdatok.tblPontozas.FieldByName('Veresg').AsString:=ComboBox3.Text;
      dmAdatok.tblPontozas.Post;
      kilep:=true;
     end;
    end;
   end;
  end;
  idTor:begin
   kilep:=true;
   try
    dmAdatok.tblPontozas.Delete;
   except
    ShowMessage('A rekord nem trlhet! (Van ilyen pontozs vad)');
    kilep:=false;
   end;
  end;
 end;
 if kilep then
  ModalResult:=mrOk;
end;

procedure TfrmPontozas.btnMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TfrmPontozas.Create(AOwner:TComponent; AFunkcio:TMuvelet);
var i:integer; s:string;
begin
 inherited Create(Owner);
 Funkcio:=AFunkcio;
 Caption:=MuveletNev[Funkcio];
 for i:=PontTol to PontIg do begin
  ComboBox1.Items.Add(IntToStr(i));
  ComboBox2.Items.Add(IntToStr(i));
  ComboBox3.Items.Add(IntToStr(i));
 end;
 case Funkcio of
  idUj:begin
   Edit1.Text:=''; ComboBox1.Text:='';
   ComboBox2.Text:=''; ComboBox3.Text:='';
  end;
  idMod,idTor:begin
   Edit1.Text:=dmAdatok.tblPontozas.FieldByName('Nv').AsString;
   s:=dmAdatok.tblPontozas.FieldByName('Gyzelem').AsString;
   ComboBox1.ItemIndex:=ComboBox1.Items.IndexOf(s);
   s:=dmAdatok.tblPontozas.FieldByName('Dntetlen').AsString;
   ComboBox2.ItemIndex:=ComboBox2.Items.IndexOf(s);
   s:=dmAdatok.tblPontozas.FieldByName('Veresg').AsString;
   ComboBox3.ItemIndex:=ComboBox3.Items.IndexOf(s);
   if Funkcio=idTor then begin
    ComboBox1.Enabled:=false;
    ComboBox2.Enabled:=false;
    ComboBox3.Enabled:=false;
   end;
  end;
 end;
end;

end.
