unit Tabella;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, QuickRpt, DBTables, Db, Qrctrls, StdCtrls, Alap, Adatok;

type
  TfrmTabella = class(TForm)
    Tabella_qry: TQuery;
    QuickRep1: TQuickRep;
    QRGroup1: TQRGroup;
    QRBand1: TQRBand;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    QRDBText7: TQRDBText;
    QRDBText8: TQRDBText;
    QRDBText9: TQRDBText;
    QRBand2: TQRBand;
    QR_Cim: TQRLabel;
    QRImage1: TQRImage;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    {Egy csapat egy meccsnek adminisztrlsa}
    procedure Novel(csop,csap,rg,kg,gy,d,v:integer);
    {Tabellakszts a kivlasztott bajnoksg sszes csoportjra}
    procedure TabellaKeszit;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

{Egy csapat egy meccsnek adminisztrlsa}
procedure TfrmTabella.Novel(csop,csap,rg,kg,gy,d,v:integer);
begin
 with dmAdatok.tblTabella do begin
  Locate('Csoport;Csapat',VarArrayOf([csop,csap]),[]);
  Edit;
  FieldByName('Mrkzs').AsInteger:=
   FieldByName('Mrkzs').AsInteger+1;
  FieldByName('Rgottgl').AsInteger:=
   FieldByName('Rgottgl').AsInteger+rg;
  FieldByName('Kapottgl').AsInteger:=
   FieldByName('Kapottgl').AsInteger+kg;
  if rg>kg then begin
   FieldByName('Gyzelem').AsInteger:=
    FieldByName('Gyzelem').AsInteger+1;
   FieldByName('Pont').AsInteger:=
    FieldByName('Pont').AsInteger+gy;
  end else
  if rg<kg then begin
   FieldByName('Veresg').AsInteger:=
    FieldByName('Veresg').AsInteger+1;
   FieldByName('Pont').AsInteger:=
    FieldByName('Pont').AsInteger+v;
  end else begin
   FieldByName('Dntetlen').AsInteger:=
    FieldByName('Dntetlen').AsInteger+1;
   FieldByName('Pont').AsInteger:=
    FieldByName('Pont').AsInteger+d;
  end;
  post;
 end;
end;

{Tabellakszts a kivlasztott bajnoksg sszes csoportjra}
procedure TfrmTabella.TabellaKeszit;
var qry:TQuery; gy,d,v:integer; ok:boolean;
begin
 {A megfelel pontozsi rtkek}
 with dmAdatok.tblPontozas do begin
  FindKey([dmAdatok.tblEvad.FieldByName('Pontozs').AsInteger]);
  gy:=FieldByName('Gyzelem').AsInteger;
  d:=FieldByName('Dntetlen').AsInteger;
  v:=FieldByName('Veresg').AsInteger;
 end;
 qry:=TQuery.Create(Self);
 qry.DatabaseName:=AliasNev;
 {Lekrdezzk a bajnoksg csapatait}
 qry.sql.Clear;
 qry.sql.Add(
  'select csb.csoport,csb.csapat from csoportbeoszts csb '+
  ' where csb.csoport in '+
  '  (select cso.kd from csoport cso,vad ev,szezon sz '+
  '   where cso.vad=ev.kd and cso.szezon=sz.kd and '+
  '         ev.kd='+AktEvad+' and sz.kd='+AktSzezon+')');
 qry.Open;
 {Felvesszk a lekrdezett csapatokat a tabellba 0 rtkekkel}
 with dmAdatok.tblTabella do begin
  qry.First;
  while not qry.Eof do begin
   Append;
   FieldByName('Csoport').AsString:=
    qry.FieldByName('Csoport').AsString;
   FieldByName('Csapat').AsString:=
    qry.FieldByName('Csapat').AsString;
   FieldByName('Mrkzs').AsInteger:=0;
   FieldByName('Gyzelem').AsInteger:=0;
   FieldByName('Dntetlen').AsInteger:=0;
   FieldByName('Veresg').AsInteger:=0;
   FieldByName('Rgottgl').AsInteger:=0;
   FieldByName('Kapottgl').AsInteger:=0;
   FieldByName('Pont').AsInteger:=0;
   Post;
   qry.Next;
  end;
 end;
 {Lekrdezzk a bajnoksg mrkzseit}
 with qry do begin
  Close;
  sql.Clear;
  sql.Add(
   'select * from mrkzs merk '+
   'where merk.csoport in '+
   ' (select cso.kd from csoport cso,vad ev,szezon sz '+
   '  where cso.vad=ev.kd and cso.szezon=sz.kd and '+
   '        ev.kd='+AktEvad+' and sz.kd='+AktSzezon+')');
  Open;
  {Adminisztrljuk ket a tabelln}
  First;
  while not Eof do begin
   {Hazai csapat}
   Novel(FieldByName('Csoport').AsInteger,
         FieldByName('Hazaicsapat').AsInteger,
         FieldByName('Hazaigl').AsInteger,
         FieldByName('Vendggl').AsInteger,gy,d,v);
   {Vendg csapat}
   Novel(FieldByName('Csoport').AsInteger,
         FieldByName('Vendgcsapat').AsInteger,
         FieldByName('Vendggl').AsInteger,
         FieldByName('Hazaigl').AsInteger,gy,d,v);
   Next;
  end;
 end;
 qry.Free;
 {A Tabella_qry lekrdezs SQL parancst tervezsi idben}
 {adtuk meg, gy a jelentsre az egyes adatmezk feltehetk}
 Tabella_qry.Open;
end;

procedure TfrmTabella.FormCreate(Sender: TObject);
begin
 TabellaKeszit;
end;

end.
