unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button2: TButton;
    Button3: TButton;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Db:word;
    procedure Uzen(Sender:TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
 with TButton(Sender) do
  ShowMessage('Parent:'+Parent.Name+' Owner:'+Owner.Name);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var btn:TButton;
begin
 inc(db);
 btn:=TButton.Create(Self);
 with btn do begin
  Parent:=Self;
  Top:=y;
  Left:=x;
  Width:=100;
  Name:=Format('Gomb%d',[Db]);
  Caption:=Format('(X:%d, Y:%d)',[x,y]);
  OnClick:=Uzen;
 end;
end;

procedure TForm1.Uzen(Sender:TObject);
begin
 if Sender is TButton then
  ShowMessage('Name:'+TButton(Sender).Name);
end;

procedure TForm1.Button2Click(Sender: TObject);
var i:integer;
begin
 for i:=1 to Self.ComponentCount do
  ShowMessage(Self.Components[i-1].Name);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Db:=0;
end;

procedure TForm1.Button3Click(Sender: TObject);
var i:integer;
begin
 i:=1;
 while i<=Self.ComponentCount do
  if copy(Self.Components[i-1].Name,1,4)='Gomb' then
   Self.Components[i-1].Free
  else inc(i);
 Db:=0;
end;

end.
