unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Unit2, Unit3;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    procedure GombKezelo1_4(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    {Hogy mdostani is tudjuk a bekrt adatokat}
    Szoveg,Rendszam,LottoszamSt:string;
    Lottoszam:1..90;
    {A Form3 rendszm bekrshez}
    function RendszamJoJelek(Rendszam:string):Jelek;
    function RendszamTartalom(Rendszam:string):boolean;
    {A Form3 lottszm bekrshez}
    function LottoszamJoJelek(Lottoszam:string):Jelek;
    function LottoszamTartalom(Lottoszam:string):boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GombKezelo1_4(Sender: TObject);
var st:string;
begin
 with TButton(Sender) do
  case Tag of
   1:MessageDlg(Caption,mtWarning,[mbOk],0);
   2:MessageDlg(Caption,mtError,[mbOk],0);
   3:MessageDlg(Caption,mtInformation,[mbOk],0);
   4:case MessageDlg(Caption+'?',mtConfirmation,[mbYes,MbNo],0) of
      mrYes:ShowMessage('Yes gomb');
      mrNo:ShowMessage('No gomb');
      else ShowMessage('Ablak bezrs');
     end;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 Szoveg:=InputBox('Adatbekrs','A szveg:',Szoveg);
 ShowMessage('A bekrt szveg:'+Szoveg);
end;

{nll ellenrz fggvny}
function NemuresEllenorzoFgv(Mit:string):boolean;
begin
 if Mit='' then begin
  ShowMessage('Nem lehet res!');
  Result:=false;
 end else
  Result:=true;
end;

procedure TForm1.Button6Click(Sender: TObject);
var Form2:TForm2;
begin
 Form2:=TForm2.Create(Self,'Szvegbekrs','A szveg:',Szoveg,
  0{0:nincs hossz korlt},NemUresEllenorzoFgv);
 case Form2.ShowModal of
  mrOk:begin
        Szoveg:=Form2.Edit1.Text;
        ShowMessage('A bekrt szveg:'+Szoveg);
       end;
  mrCancel:ShowMessage('Mgsem gomb');
 end;
 Form2.Free;
end;

{nll rendszm ellenrz fggvny}
function RendszamEllenorzoFgv(Mit:string):boolean;
var ok:boolean; i:integer;
begin
 ok:=true;
 if length(Mit)<>6 then begin
  ShowMessage('Nem 6 karakterbl ll!');
  ok:=false;
 end else begin
  for i:=1 to 6 do
   if (i in [1..3]) and not (Mit[i] in ['A'..'Z']) or
      (i in [4..6]) and not (Mit[i] in ['0'..'9']) then
    ok:=false;
  if not ok then
   ShowMessage('Nem megfelel karakterek!')
  else
   if copy(Mit,4,3)='000' then begin
    ShowMessage('A szmrsz nem lehet csupa 0!');
    ok:=false;
   end;
 end;
 Result:=ok;
end;

procedure TForm1.Button7Click(Sender: TObject);
var Form2:TForm2;
begin
 Form2:=TForm2.Create(Self,'Rendszmbekrs','A rendszm:',
  Rendszam,6,RendszamEllenorzoFgv);
 case Form2.ShowModal of
  mrOk:begin
        Rendszam:=Form2.Edit1.Text;
        ShowMessage('A bekrt rendszm:'+Rendszam);
       end;
  mrCancel:ShowMessage('Mgsem gomb');
 end;
 Form2.Free;
end;

{Az elfogadhat karakterek belltsa rendszm esetn}
function TForm1.RendszamJoJelek(Rendszam:string):Jelek;
begin
 case length(Rendszam) of
  0..2:Result:=['A'..'Z'];
  3..4:Result:=['0'..'9'];
  5:begin
     if Copy(Rendszam,4,2)='00' then
      Result:=['1'..'9']
     else
      Result:=['0'..'9'];
    end;
  else Result:=[];
 end;
 {Backspace}
 if length(Rendszam)>0 then
  Result:=Result+[chr(vk_back)];
end;

{Rendszm tartalmi ellenrzs}
function TForm1.RendszamTartalom(Rendszam:string):boolean;
begin
 if length(Rendszam)<6 then begin
  ShowMessage('Hinyz karakterek!');
  Result:=false;
 end else
  Result:=true;
end;

procedure TForm1.Button8Click(Sender: TObject);
var Form3:TForm3;
begin
 Form3:=TForm3.Create(Self,'Rendszmbekrs','A rendszm:',
  Rendszam,RendszamJojelek,RendszamTartalom);
 case Form3.ShowModal of
  mrOk:begin
        Rendszam:=Form3.Edit1.Text;
        ShowMessage('A bekrt rendszm:'+Rendszam);
       end;
  mrCancel:ShowMessage('Mgsem gomb');
 end;
 Form3.Free;
end;

{Az elfogadhat karakterek belltsa (5-s) lottszm esetn}
function TForm1.LottoszamJoJelek(Lottoszam:string):Jelek;
begin
 case length(Lottoszam) of
  0:Result:=['1'..'9'];
  1:begin
     if Lottoszam[1]='9' then
      Result:=['0']
     else
      Result:=['0'..'9'];
    end;
  else Result:=[];
 end;
 {Backspace}
 if length(Lottoszam)>0 then
  Result:=Result+[chr(vk_back)];
end;

{Lottoszm tartalmi ellenrzs}
function TForm1.LottoszamTartalom(Lottoszam:string):boolean;
begin
 if length(Lottoszam)=0 then begin
  ShowMessage('Hinyz adat!');
  Result:=false;
 end else
  Result:=true;
end;

procedure TForm1.Button9Click(Sender: TObject);
var Form3:TForm3;
begin
 Form3:=TForm3.Create(Self,'Lottszm (5-s) bekrs','A lottszm:',
  LottoszamSt,LottoszamJojelek,LottoszamTartalom);
 case Form3.ShowModal of
  mrOk:begin
        LottoszamSt:=Form3.Edit1.Text;
        Lottoszam:=StrToInt(LottoszamSt);
        ShowMessage('A bekrt lottszm:'+IntToStr(Lottoszam));
       end;
  mrCancel:ShowMessage('Mgsem gomb');
 end;
 Form3.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Szoveg:=''; Rendszam:=''; LottoszamSt:='';
end;

end.
