unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Valasztas, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Label1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
 Accept:={true}false;
end;

procedure TForm1.Label2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 {TLabel(Sender).BeginDrag(true);}
 TLabel(Sender).BeginDrag(false,5);
end;

procedure TForm1.ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
 if Source is TLabel then
  TListBox(Sender).Items.Add(TLabel(Source).Caption);
end;

procedure TForm1.Label1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var st:string;
begin
 case State of
  dsDragEnter:st:='Enter';
  dsDragLeave:st:='Leave';
  dsDragMove:st:='Move';
 end;
 ListBox1.Items.Add(TLabel(Sender).Name+
  '  '+TLabel(Source).Name+'  '+st);
end;

procedure TForm1.Button1Click(Sender: TObject);
var vf:TValasztasForm; mit:TStringList;
    i:integer; st:string;
begin
 mit:=TStringList.Create;
 mit.Add('Szab Szilvia');
 mit.Add('Kovcs Kinga');
 mit.Add('Asztalos Anita');
 mit.Add('Takcs Tmea');
 mit.Add('Halsz Helga');
 mit.Add('Vadsz Viktria');
 mit.Add('Madarsz Mnika');
 vf:=TValasztasForm.Create(Self,mit,'Bartnk','Jelltek',
 'Kivlasztottak');
 if vf.ShowModal=mrOk then begin
  if vf.lbHova.Items.Count=0 then
   ShowMessage('Nincs kivlasztott nv!')
  else begin
   st:='';
   for i:=1 to vf.lbHova.Items.Count do
    st:=st+vf.lbHova.Items[i-1]+chr(13);
   st:=copy(st,1,length(st)-1);
   ShowMessage('A kivlasztott(ak):'+chr(13)+st)
  end;
 end;
 mit.Free;
 vf.Free;
end;

end.
